﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace testXamGridApp
{
    public class DummyData : INotifyPropertyChanged
    {
        private string _name;
        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
                OnPropertyChanged("Name");
            }
        }
        private DateTime _date;
        public DateTime Date
        {
            get
            {
                return _date;
            }
            set
            {
                _date = value;
                OnPropertyChanged("Date");
            }
        }

        private string _selectedDateText;
        public string SelectedDateText
        {
            get
            {
                return _selectedDateText;
            }
            set
            {
                _selectedDateText = value;
                OnPropertyChanged("SelectedDateText");
            }
        }

        private int _unboundData;
        public int UnboundData
        {
            get
            {
                return _unboundData;
            }
            set
            {
                _unboundData = value;
            }
        }
    
        public event PropertyChangedEventHandler  PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class DummyDataCollection : ObservableCollection<DummyData>
    {
        public DummyDataCollection()
        {
            Add(new DummyData() { Date = DateTime.Now, Name = "Name 1" });
            Add(new DummyData() { Date = DateTime.Now, Name = "Name 2" });
            Add(new DummyData() { Date = DateTime.Now, Name = "Name 3" });
            Add(new DummyData() { Date = DateTime.Now, Name = "Name 4" });
            Add(new DummyData() { Date = DateTime.Now, Name = "Name 5" });
        }
    }
}
