﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using System.Windows.Data;

namespace testXamGridApp
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            Style s = new Style();
            s.TargetType = typeof(ConditionalFormattingCellControl);
            s.Setters.Add(new Setter(ConditionalFormattingCellControl.BackgroundProperty, new SolidColorBrush(Colors.Green)));
            s.Setters.Add(new Setter(ConditionalFormattingCellControl.AltBackgroundProperty, new SolidColorBrush(Colors.Green)));

            CustomEqualToConditionalFormatRule equalRule = new CustomEqualToConditionalFormatRule();
            equalRule.Value = 1;
            equalRule.StyleToApply = s;
            equalRule.StyleScope = StyleScope.Cell;
            equalRule.ShouldRefreshOnDataChange = true;

            UnboundColumn imgColumn = new UnboundColumn() { Key = "TestName0" };
            imgColumn.ValueConverter = new CommentTypeIconCoverterX();
            imgColumn.ValueConverterParameter = "TestName0";
            imgColumn.HeaderText = " ";
            imgColumn.ConditionalFormatCollection.Add(equalRule);
            xamGrid1.Columns.Add(imgColumn);
        }
    }
    public class CommentTypeIconCoverterX : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            // Do your logic on the parameter that you passed it.
            if ((string)parameter == "TestName0")
            {
                DummyData data = value as DummyData;
                data.UnboundData = 1;
                return data.UnboundData;
            }

            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class CustomEqualToConditionalFormatRule : ConditionalFormattingRuleBase
    {
        public object Value { get; set; }

        public Style StyleToApply { get; set; }

        protected override IConditionalFormattingRuleProxy CreateProxy()
        {
            return new CustomEqualToConditionalFormatRuleProxy(Value, StyleToApply);
        }
    }

    public class CustomEqualToConditionalFormatRuleProxy : ConditionalFormattingRuleBaseProxy
    {
        private object Value { get; set; }

        private Style StyleToApply { get; set; }

        public CustomEqualToConditionalFormatRuleProxy(object value, Style style)
        {
            Value = value;
            StyleToApply = style;
        }

        protected override Style EvaluateCondition(object sourceDataObject, object sourceDataValue)
        {
            DummyData data = sourceDataObject as DummyData;
            // Convert the value to an integer since we're checking against an integer.
            if (Value.GetType() == typeof(int) && data.UnboundData == (int)Value)
                return StyleToApply;

            return null;
        }
    }
}
